(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('bootstrap-datepicker'), require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', 'bootstrap-datepicker', '@angular/core', '@angular/forms', '@angular/common'], factory) :
	(factory((global['ngq-datepicker'] = {}),null,global.ng.core,global.ng.forms,global.ng.common));
}(this, (function (exports,bootstrapDatepicker,core,forms,common) { 'use strict';

var BASE_OPTION = ({
    autoclose: true,
    format: 'dd/mm/yyyy',
    language: 'en-GB'
});
var th_TH = (Object.assign({}, BASE_OPTION, { language: 'th-TH' }));
var en_GB = (Object.assign({}, BASE_OPTION, { language: 'en-GB' }));
var NGQ_DATETIME_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return NgqDatepickerComponent; }),
    multi: true
};
var NgqDatepickerComponent = /** @class */ (function () {
    function NgqDatepickerComponent() {
        this.propagateChange = function (_) { };
    }
    Object.defineProperty(NgqDatepickerComponent.prototype, "opts", {
        set: function (opts) {
            this._opts = opts;
            if (this._jQueryElement) {
                this._jQueryElement.datepicker('destroy');
                var newVal = !!this._value
                    ? new Intl.DateTimeFormat(this._opts.language).format(this._value)
                    : '';
                this._jQueryElement.val(newVal);
                this.initDatepicker();
            }
        },
        enumerable: true,
        configurable: true
    });
    NgqDatepickerComponent.prototype.ngAfterViewInit = function () {
        this._jQueryElement = jQuery(this.input.nativeElement);
        this.initDatepicker();
    };
    NgqDatepickerComponent.prototype.initDatepicker = function () {
        var _this = this;
        this._opts = this._opts ? this._opts : th_TH;
        this._jQueryElement.datepicker(this._opts);
        this._jQueryElement.datepicker().on('changeDate', function (e) {
            _this._value = e.date;
            _this.propagateChange(_this._value);
        });
        this._jQueryElement.datepicker('update', this._value);
        this._jQueryElement.prop('disabled', this._isDisabled);
    };
    NgqDatepickerComponent.prototype.onChange = function (value) {
        if (!value) {
            this._value = null;
            this.propagateChange(this._value);
        }
        else {
            if (this._jQueryElement) {
                this._jQueryElement.datepicker('destroy');
                this.initDatepicker();
            }
        }
    };
    NgqDatepickerComponent.prototype.writeValue = function (obj) {
        this._value = obj;
        if (this._jQueryElement) {
            this._jQueryElement.datepicker('update', this._value);
        }
    };
    NgqDatepickerComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    NgqDatepickerComponent.prototype.registerOnTouched = function (fn) { };
    NgqDatepickerComponent.prototype.setDisabledState = function (isDisabled) {
        this._isDisabled = isDisabled;
        if (this._jQueryElement) {
            this._jQueryElement.prop('disabled', this._isDisabled);
        }
    };
    return NgqDatepickerComponent;
}());
NgqDatepickerComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ngq-datepicker',
                template: "<div *ngIf=\"!hideIcon\" class=\"input-group\">\n  <input #input type=\"text\" [attr.class]=\"class\" [attr.id]=\"id\" [attr.placeholder]=\"placeholder\" (change)=\"onChange($event.target.value)\">\n  <div class=\"input-group-addon\" (click)=\"_jQueryElement.datepicker('show')\">\n    <span class=\"glyphicon glyphicon-calendar\"></span>\n  </div>\n</div>\n<input *ngIf=\"hideIcon\" #input type=\"text\" [attr.class]=\"class\" [attr.id]=\"id\" [attr.placeholder]=\"placeholder\" (change)=\"onChange($event.target.value)\">\n",
                styles: [":host{outline:0}"],
                providers: [NGQ_DATETIME_VALUE_ACCESSOR]
            },] },
];
NgqDatepickerComponent.ctorParameters = function () { return []; };
NgqDatepickerComponent.propDecorators = {
    "hideIcon": [{ type: core.Input },],
    "id": [{ type: core.Input },],
    "class": [{ type: core.Input },],
    "placeholder": [{ type: core.Input },],
    "input": [{ type: core.ViewChild, args: ['input',] },],
    "opts": [{ type: core.Input, args: ['opts',] },],
};
var NgqDatepickerModule = /** @class */ (function () {
    function NgqDatepickerModule() {
    }
    return NgqDatepickerModule;
}());
NgqDatepickerModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [common.CommonModule],
                declarations: [NgqDatepickerComponent],
                exports: [NgqDatepickerComponent]
            },] },
];
NgqDatepickerModule.ctorParameters = function () { return []; };

exports.BASE_OPTION = BASE_OPTION;
exports.th_TH = th_TH;
exports.en_GB = en_GB;
exports.NgqDatepickerComponent = NgqDatepickerComponent;
exports.NgqDatepickerModule = NgqDatepickerModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngq-datepicker.umd.js.map
